/*
 * failover -- The failover cmd tool.
 *
 * Copyright (C) 2009, OpenVox
 *
 * mark.liu <mark.liu@openvox.cn>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 *
 */

#ifndef SERIAL_H_
#define SERIAL_H_

#include <termios.h>
#include <errno.h>
#include <sysexits.h>
#include <ctype.h>

#define MAX_DEVICE_NAME 128
#define MAX_CMD_NAME 64
#define MAX_PARAM_NAME 8

/* serial port default value */
#define DEFAULT_SPEED	"1200"
#define DEFAULT_PARMS	"8n1"

/* failover config file */
#define FAILOVER_CONFIG_FILE "failover.conf"

/* failover serial device */
typedef struct tty_struct {
	int				fd;
	char			tty_name[MAX_DEVICE_NAME];
	struct termios	termios_state;
	speed_t			baudrate;
}tty_struct_t;

/* baudrates */
typedef struct speed_struct {
	speed_t	speed;
	char	*speedstr;
} speed_struct_t;

speed_t parse_baurd(char *speed);
int parse_parms(tcflag_t *c, char *parms, int flow, int modem);
void print_parms(struct termios *ti, char *tty_name);

#endif
